package pds.xml;

import java.io.PrintStream;
import java.io.PrintWriter;

/**
 * MultiWriter is a class that will write to one or more streams.
 * After creating an instance set the output writer with a call to setWriter().
 *
 * @author      Todd King
 * @author      Planetary Data System
 * @version     1.0, 6/22/04
 * @since       1.0
 */

public class MultiWriter {
	PrintStream	mStream = null;
	PrintWriter mWriter = null;
	
	public void reset() {
		mStream = null;
		mWriter = null;
	}
	
	public void setStream(PrintStream stream) {
		mStream = stream;
	}
	
	public void setWriter(PrintWriter writer) {
		mWriter = writer;
	}
	
	public void print(char c) {
		if(mStream != null) mStream.print(c);
		if(mWriter != null) mWriter.print(c);
	}
	
	public void print(String text) {
		if(mStream != null) mStream.print(text);
		if(mWriter != null) mWriter.print(text);
	}
	
	public void println(String text) {
		if(mStream != null) mStream.println(text);
		if(mWriter != null) mWriter.println(text);
	}
	
	public void write(char[] buffer, int n) {
		if(mStream != null) {
			for(int i = 0; i < n; i++) mStream.print(buffer[i]);
		}
		if(mWriter != null) mWriter.write(buffer, 0, n);
	}

}
		
	
