package pds.util;

import java.io.BufferedReader;
import java.util.ArrayList;

/**
* <p>
* File: PPIThreadedReader
* Purpose: To ensure access to standar error System.err
* when reading a buffered stream with System.in.
* <p>
*
* @author Todd King
*/
public class PPIThreadedReader extends Thread {
	private ArrayList mBuffer;
	private BufferedReader mReader;
	
	/**
	 * @param in	either standard err or standard in
	 *
	 * @param out 	to store the output
	 **/
	public PPIThreadedReader(BufferedReader reader, ArrayList out) 
	{
		mBuffer = out;
		mReader = reader;
	}
	
	/**
	 * Do the thread's work
	 **/
	public void run() 
	{
		String	buffer;
		
		try {
		// hold character data in the buffer until we get to the end
			while((buffer = mReader.readLine()) != null) mBuffer.add(buffer);
		} catch (Exception e) {
			// tack the error message onto the end of the data stream
			mBuffer.add("Error reading data:" + e.getMessage());
		}
	}
}